<template>
  <div class="app-container-page">
    <el-form class="table-form-search" :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch"
      label-width="90px">
      <el-row>
        <el-col :span="8">
          <el-form-item label="编码" prop="typeCode">
            <el-input v-model="queryParams.typeCode" placeholder="请输入编码" clearable @keyup.enter="handleQuery" />
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="名称" prop="typeName">
            <el-input v-model="queryParams.typeName" placeholder="请输入名称" clearable @keyup.enter="handleQuery" />
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="首字母代码" prop="firstLetter">
            <el-input v-model="queryParams.firstLetter" placeholder="请输入首字母代码" clearable @keyup.enter="handleQuery" />
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="8">
          <el-form-item label="描述" prop="description">
            <el-input v-model="queryParams.description" placeholder="请输入描述" clearable @keyup.enter="handleQuery" />
          </el-form-item>
        </el-col>
        <el-col :span="16" class="searchBtn">
          <el-form-item>
            <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
            <el-button icon="Refresh" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>

    <div class="table-list">

      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-button type="primary" plain icon="Plus" @click="handleAdd(null)"
            v-hasPermi="['worn:type:add']">新增</el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"
            v-hasPermi="['worn:type:remove']">删除</el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button type="warning" plain icon="Download" @click="handleExport"
            v-hasPermi="['worn:type:export']">导出</el-button>
        </el-col>
        <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
      </el-row>

      <el-table v-loading="loading" :data="typeList" @selection-change="handleSelectionChange" default-expand-all
        :tree-props="{ children: 'children', hasChildren: 'hasChildren' }" row-key="id" border>
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="编码" align="center" prop="typeCode" />
        <el-table-column label="名称" align="center" prop="typeName" />
        <el-table-column label="首字母代码" align="center" prop="firstLetter" />
        <el-table-column label="描述" align="center" prop="description" />
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-button link type="primary" icon="Plus" @click="handleAdd(scope.row)" v-hasPermi="['worn:type:add']"
              v-if="scope.row.level < 3">新增</el-button>
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
              v-hasPermi="['worn:type:edit']">修改</el-button>
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
              v-hasPermi="['worn:type:remove']">删除</el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum"
        v-model:limit="queryParams.pageSize" @pagination="getList" />
    </div>

    <!-- 添加或修改废旧系统物料类型对话框 -->
    <el-dialog :title="title" v-model="open" width="600px" append-to-body destroy-on-close>
      <el-form ref="typeRef" :model="form" :rules="rules" label-width="90px">
        <div v-if="optionType != 0">
          <el-form-item label="上级类型" prop="parentTypeName">
            <el-input v-model="form.parentTypeName" :disabled="true" placeholder="请输入上级类型" />
          </el-form-item>
        </div>
        <el-form-item label="名称" prop="typeName">
          <el-input v-model="form.typeName" placeholder="请输入名称" />
        </el-form-item>
        <el-form-item label="编码" prop="typeCode">
          <el-input v-model="form.typeCode" :disabled="true" placeholder="编码代码自动生成" />
        </el-form-item>
        <el-form-item label="首字母代码" prop="firstLetter">
          <el-input v-model="form.firstLetter" :disabled="true" placeholder="首字母代码自动生成" />
        </el-form-item>
        <el-form-item label="描述" prop="description">
          <el-input v-model="form.description" placeholder="请输入描述" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Type">
import { listType, getType, delType, addType, updateType } from "@/api/worn/type"

const { proxy } = getCurrentInstance()


const open = ref(false)
const loading = ref(true)
const multiple = ref(true)
const showSearch = ref(true)

const ids = ref([])
const typeList = ref([])

const total = ref(0)
const optionType = ref(0) //0新增 1修改  2子级新增

const title = ref("")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    typeCode: null,
    typeName: null,
    firstLetter: null,
    description: null,
  },
  rules: {
    typeName: [
      { required: true, message: "名称不能为空", trigger: "blur" }
    ],
  }
})
const { queryParams, form, rules } = toRefs(data)
/** 查询废旧系统物料类型（支持父子级树结构）列表 */
function getList() {
  loading.value = true
  typeList.value = []
  listType(queryParams.value).then(response => {
    typeList.value = proxy.handleTree(response.rows, "id")
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    typeCode: null,
    typeName: null,
    firstLetter: null,
    description: null,
  }
  proxy.resetForm("typeRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd(row) {
  reset()
  // 存在row值 则为子级增加 type为2 存在父级类型栏位
  if (row) {
    form.value = { parentTypeName: row.typeName, parentId: row.id }
    optionType.value = 2
  } else {
    optionType.value = 0
  }
  open.value = true
  title.value = "添加物料类型"
}


/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _id = row.id || ids.value
  getType(_id).then(response => {
    form.value = { ...response.data, parentTypeName: response.data.typeName }
    optionType.value = 1
    open.value = true
    title.value = "修改物料类型"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["typeRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateType(form.value).then(response => {
          console.log(response, 'response');
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        if (optionType.value == 2) {
          delete form.value.parentTypeName
        }
        addType(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value
  proxy.$modal.confirm('是否确认删除废旧系统物料类型编号为"' + _ids + '"的数据项？').then(function () {
    return delType(_ids)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => { })
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('worn/type/export', {
    ...queryParams.value
  }, `物料类型_${new Date().getTime()}.xlsx`)
}

getList()
</script>
